package com.example.image;
import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.ImageView;
import android.widget.LinearLayout;

/**
 * 画像ファイルの描画サンプル
 */
public class ImageSample extends Activity {
	//必要なだけの幅を表示
    private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
    //画面幅最大で表示
    private final int FP = ViewGroup.LayoutParams.FILL_PARENT; 
    
    /**
     * アプリケーションの初期化
     */
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        
        //アプリケーションタイトルを非表示
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        
        //レイアウトを縦表示設定で作成
        LinearLayout layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);
        
        //最初の画像ファイルを生成
        Bitmap bmp = BitmapFactory.decodeResource(getResources(), R.drawable.android);
        ImageView image = new ImageView(this);
        
        //イメージビューへ画像ファイルを設定
        image.setImageBitmap(bmp);

        //次の画像ファイルを生成
        Bitmap bmp2 = BitmapFactory.decodeResource(getResources(), R.drawable.market_bag);
        ImageView image2 = new ImageView(this);
        //イメージビューへ画像ファイルを設定
        image2.setImageBitmap(bmp2);
        
        //イメージビューをレイアウトに設定（画面）
        layout.addView(image, createParam(FP, WC));
        layout.addView(image2, createParam(FP, WC));
    }
    /**
     * レイアウトパラメータの取得
     * @param w		Widthを指定
     * @param h		heigthを指定
     * @return	レイアウトパラメータ
     */
    private LinearLayout.LayoutParams createParam(int w, int h){
        return new LinearLayout.LayoutParams(w, h);
    }
}