package com.example.schedule;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedHashMap;

import com.example.schedule.util.ScheduleUtil;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.app.TimePickerDialog;
import android.app.AlertDialog.Builder;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.Bundle;
import android.text.InputFilter;
import android.text.InputType;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.TimePicker;
import android.widget.CompoundButton.OnCheckedChangeListener;
public class ScheduleEditor  extends Activity 
	implements OnCheckedChangeListener,OnClickListener{
    private EditText edtTitle;//^Cg
    private EditText edtBody; //{
    private EditText edtYear;//N
    private EditText edtMonth;//
    private EditText edtDay;//
    private EditText edtHour;//
    private EditText edtMinuts;//
    private CheckBox chkAlarm ;//A[w`FbN{bNX
    private Button addBtn;//XPW[ǉ{^
    private Button deleteBtn;//폜{^

    //ʍő啝ŕ\
    private final int FP = ViewGroup.LayoutParams.FILL_PARENT;
    //KvȒlŕ\
    private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
    private int      scheduleID;  //XPW[ID
    /**
     * ʂ̍쐬ɌĂяo
     * @Override
     */
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        setLayout();
        //t@Cf[^̓ǂݍ
        //String testValue = ScheduleUtil.readFile(this, "test.txt");
        //t@Cǂݍ񂾒l^CgɃZbg
        //edtTitle.setText(testValue);
        //readScheduleBody("test.properties");
        //p[^̎擾
        String memoTitle="";
        Bundle extras=getIntent().getExtras();
        if (extras!=null) {
            scheduleID=extras.getInt("id");
            memoTitle=extras.getString("title");
            edtTitle.setText(memoTitle);
        }
        //readScheduleBody("test.properties");
        readScheduleBody(scheduleID+".properties");
    }
    /**
     * {fB̓ǂݍ
     * @param fileName
     */
    private void readScheduleBody(String fileName) {
        try {
            //vpeB̓ǂݍ
            HashMap<String, String> prop = ScheduleUtil.readProperties(this,fileName);
            if(prop != null){
                //{̓ǂݍ
                String text = (String) prop.get("text");
                //vpeBt@Cǂ݂񂾒lʂɐݒ
                edtBody.setText(text);
                //vpeBtݒ肳Ă
                if(prop.containsKey("schedule")){
                    //vpeB擾tAttH[}bgŃtH[}bg
                    SimpleDateFormat df = new SimpleDateFormat("yyyy/MM/dd hh:mm");
                    String schedule = (String) prop.get("schedule");
                    Date d = df.parse(schedule);
                    Calendar cal = Calendar.getInstance();
                    cal.setTime(d);
                    
                    //vpeB擾t̒lʍڂɐݒ肷
                    edtYear.setText(String.valueOf(cal.get(Calendar.YEAR)));
                    edtMonth.setText(String.valueOf(cal.get(Calendar.MONTH)+1));
                    edtDay.setText(String.valueOf(cal.get(Calendar.DAY_OF_MONTH)));
                    edtHour.setText(String.valueOf(cal.get(Calendar.HOUR_OF_DAY)));
                    edtMinuts.setText(String.valueOf(cal.get(Calendar.MINUTE)));
                    
                    //vpeBɓtݒ肳Ă̂ŃA[`FbN{bNXONɐݒ
                    chkAlarm.setChecked(true);
                }
            }
        } catch (Exception e) {
            showDialog(this,"",fileName + ":t@C̓ǂݍ݂Ɏs܂B");
        }
    }


    /**
     * CAEg̐ݒ
     */
    private void setLayout(){
        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        setContentView(layout);
        layout.setOrientation(LinearLayout.VERTICAL);
        layout.setGravity(Gravity.LEFT);

        //^CgGfBbg̐
        layout.addView(makeLabel("^Cg"));
        edtTitle=makeEditor("",FP,WC); 
        edtTitle.setLines(1);
        layout.addView(edtTitle);

        //{GfBbg̐
        layout.addView(makeLabel("{"));
        edtBody=makeEditor("",FP,80);
        layout.addView(edtBody);
        


        LinearLayout layoutDate=new LinearLayout(this);
        layoutDate.setOrientation(LinearLayout.HORIZONTAL);
        
        //NGfBbg̐
        edtYear=makeNumericEditor("",WC,WC,80,4); 
        layoutDate.addView(makeLabel("N"));
        layoutDate.addView(edtYear);

        //GfBbg̐
        edtMonth=makeNumericEditor("",WC,WC,40,2); 
        layoutDate.addView(makeLabel(""));
        layoutDate.addView(edtMonth);


        //GfBbg̐
        edtDay=makeNumericEditor("",WC,WC,40,2); 
        layoutDate.addView(makeLabel(""));
        layoutDate.addView(edtDay);

        //ԃCAEg̍쐬 ɔzu
        LinearLayout layoutMinuts=new LinearLayout(this);
        layoutMinuts.setOrientation(LinearLayout.HORIZONTAL);
        
        //GfBbg̐
        layoutMinuts.addView(makeLabel(""));
        edtHour=makeNumericEditor("",WC,WC,40,2); 
        layoutMinuts.addView(edtHour);

        //GfBbg̐
        layoutMinuts.addView(makeLabel(""));
        edtMinuts=makeNumericEditor("",WC,WC,40,2); 
        layoutMinuts.addView(edtMinuts);

         
        //A[`FbN{bNX
        chkAlarm = new CheckBox(this);
        chkAlarm.setOnCheckedChangeListener(this);
        chkAlarm.setText("w莞ɃA[炷");

        //{^p̃CAEgō쐬
        LinearLayout layoutBtn =new LinearLayout(this);
        layoutBtn.setOrientation(LinearLayout.HORIZONTAL);
        
        //ǉ{^
        addBtn = new Button(this);
        addBtn.setText("XPW[o^");
        addBtn.setOnClickListener(this);
        
        //폜{^
        deleteBtn = new Button(this);
        deleteBtn.setText("XPW[폜");
//        deleteBtn.setOnClickListener(new OnClickListener() {
//            public void onClick(View v) {
//                //NbN̏Lq
//                showDialog(ScheduleEditor.this,"","XPW[폜{^NbN1");
//            }
//        });
        deleteBtn.setOnClickListener(this);

        
//      //WI{^̐
//      RadioButton radio1 = new RadioButton(this);
//      radio1.setId(0);
//      radio1.setText("WI{^P");
//
//      //WI{^̐
//      RadioButton radio2 = new RadioButton(this);
//      radio2.setId(1);
//      radio2.setText("WI{^Q");
//      
//      //WIO[v̍쐬AWI{^̒ǉ        
//      RadioGroup rg = new RadioGroup(this);
//      rg.addView(radio1);
//      rg.addView(radio2);
//      rg.check(0);
//      rg.setLayoutParams(new LinearLayout.LayoutParams(WC, WC));
//      layout.addView(rg);

        
        //{^CAEgɒǉ{^A폜{^ǉ
        layoutBtn.addView(addBtn);
        layoutBtn.addView(deleteBtn);


        //ʃCAEgɃA[`FbN{bNXǉ
        layout.addView(chkAlarm);
        //ʃCAEgɓtCAEgǉ
        layout.addView(layoutDate);
        //ʃCAEgɎԃCAEgǉ
        layout.addView(layoutMinuts);
        //ʃCAEgɃ{^CAEgǉ
        layout.addView(layoutBtn);
    }

    /**
     * ő包ݒ肷
     * @param maxLen    ő包̕
     * @return    ő包̐ݒ肳ꂽInputFilter
     */
    private InputFilter[] setMaxlength(int maxLen){
        return 
        new InputFilter[] {
                new InputFilter.LengthFilter(maxLen)
            };
    }
    /**
     * x̐
     * @param text    TextViewɐݒ肷镶
     * @return    ̐ݒ肳ꂽTextViewIuWFNg
     */
    private TextView makeLabel(String text) {
        //TextView̐
        TextView label=new TextView(this);
        
        //TextViewɕ̐ݒ
        label.setText(text);
        
        //TextView̕\Kvŏɐݒ
        label.setLayoutParams(new LinearLayout.LayoutParams(WC,WC));
        
        return label;       
    }
    /**
     * GfB^̐
     * @param text    \镶
     * @param w    EditText̉
     * @param h    EditText̏c
     * @return    ꂽEditTextIuWFNg
     */
    private EditText makeEditor(String text,int w ,int h) {
        //EditTextIuWFNg̐
        EditText editor=new EditText(this);
        
        //EditTextIuWFNgɒl̐ݒ
        editor.setText(text);
        
        //EditTextIuWFNg񂹁A񂹂ɐݒ
        editor.setGravity(Gravity.LEFT|Gravity.TOP);
        
        //EditText̕\镶̓e\𒴂ꍇXN[\悤ݒ
        editor.setHorizontallyScrolling(true);
        
        //EditText̉Ac̐ݒ
        editor.setLayoutParams(
            new LinearLayout.LayoutParams(w,h));
        
        return editor;
    }
    /**
     * l̂ݓ͉\ȃGfB^̐
     * @param text    \镶
     * @param w    EditText̉
     * @param h    EditText̏c
     * @param width    EditText̕\TCY
     * @param maxlen    EditTextœ͉\ȍő包
     * @return    EditTextIuWFNg
     */
    private EditText makeNumericEditor(String text,int w ,int h,int width,int maxlen) {
        //EditTextIuWFNg̐
        EditText editor=new EditText(this);
        
        //EditTextIuWFNgɒl̐ݒ
        editor.setText(text);
        
        //EditTextIuWFNg񂹁A񂹂ɐݒ
        editor.setGravity(Gravity.LEFT|Gravity.TOP);
        
        //EditText̕\镶̓e\𒴂ꍇXN[\悤ݒ
        editor.setHorizontallyScrolling(true);

        //EditText̉Ac̐ݒ
        editor.setLayoutParams(
            new LinearLayout.LayoutParams(w,h));
        
        //EditText̍ő\TCYݒ
        editor.setWidth(width);
        
        //EditText̍ő包ݒ
        editor.setFilters(setMaxlength(maxlen));
        
        //EditTextɕ̂ݓ͉\ݒ
        editor.setInputType(InputType.TYPE_CLASS_NUMBER);
        return editor;
    }

    public void onClick(View view) {
        try {
            if (view == addBtn){
               //{nbV}bv֐ݒ
                HashMap<String, String> map = new HashMap<String, String>();
                map.put("text", edtBody.getText().toString());
                //p[^̕ۑ            
                SharedPreferences pref=getSharedPreferences(
                    "PREVIOUS_RESULT",MODE_PRIVATE);
                SharedPreferences.Editor editor=pref.edit();
                
                //sꂽR}hݒ
                editor.putString("command","update");
                //ScheduleListintentɂēnꂽAݒ
                editor.putInt("id",scheduleID);
                //ʂœ͂ꂽ^Cgݒ
                editor.putString("title",edtTitle.getText().toString());
                //ʓ͂ꂽXPW[̓tYYYY/MM/DD HH:mm̌`Ŏ擾
                String scheduleDate = edtYear.getText().toString() + "/" + 
                    edtMonth.getText().toString() + "/" + 
                    edtDay.getText().toString() + " " + 
                    edtHour.getText().toString() + ":" + 
                    edtMinuts.getText().toString() ; 
                //XPW[̓tÓ`FbN
                if(ScheduleUtil.chkDate(scheduleDate)){
                    //tĂꍇ̂ݏ
                    editor.putString("schedule",scheduleDate);
                    //XPW[̓t}bvIuWFNgɐݒ
                    map.put("schedule", scheduleDate);
                }else{
                    editor.putString("schedule","");
                }
                //SharedPreferencesɐݒ肵lm肳B
                editor.commit();
                //vpeBt@Cɏ
                ScheduleUtil.writeProperties(this,map,scheduleID+".properties");
                setResult(RESULT_OK);
                finish();
            }
            //NXŎĂ邽ߌĂяoȂ
            else if(view == deleteBtn){
                //showDialog(this,"","XPW[폜{^NbN2");
                deleteSchedule();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
	/**
	 * XPW[̍폜vpeBt@C̍폜
	 */
	private void deleteSchedule(){

		//t@C̍폜
		deleteFile(scheduleID+".properties");
		
		//SharedPreferencesIuWFNgɃp[^̕ۑ			
		SharedPreferences pref=getSharedPreferences(
			"PREVIOUS_RESULT",MODE_PRIVATE);
		SharedPreferences.Editor editor=pref.edit();
		editor.putString("command","delete");
		editor.putInt("id",scheduleID);
		
		//SharedPreferencesIuWFNgcommit
		editor.commit();

		//ANeBreB̏I
		setResult(RESULT_OK); 
		finish();
	}
    /**
    * _CAO̕\
    */
    public  void showDialog(final Activity activity,String title,String text) {
        //_CAO̍쐬
        Builder ad = new AlertDialog.Builder(activity);
        
        //_CAÕ^Cg̐ݒ
        ad.setTitle(title);
        
        //_CAOɕ\郁bZ[W̐ݒ
        ad.setMessage(text);
        
        //OK{^̓
        ad.setPositiveButton("ok", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int whichButton) {
                //OK{^
            }
        });
        //LZ{^̓
        ad.setNegativeButton("cancel", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int whichButton) {
                //LZ{^
            }
        });
        //_CAO̕\
        ad.create();
        ad.show();
    }
    /**
     * ߂{^ɉʂ̏I
     * @param	keyCode	ꂽL[R[h
     * @param	event	ꂽL[Cxg
    */
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        //߂{^́Aʖ߂lOKݒ肵ĉʂI
        if (keyCode ==KeyEvent.KEYCODE_BACK) {
            setResult(RESULT_OK); 
            finish();
        } 
        return true;
    }
    private TimePickerDialog timePickerDialog;    //ԃ_CAO
    private DatePickerDialog datePickerDialog;    //t_CAO
    /**
     * `FbN{bNXύX̃Cxg
     * @param    view    `FbN{bNXIuWFNg
     * @param    isChecked    true:`FbN@falseF`FbN
     */
    public void onCheckedChanged(CompoundButton view, boolean isChecked) {
        if(view == chkAlarm){
            //showDialog(this,"","A[N{^F" + isChecked);
            //ҏWɃ`FbNꂽƂɃXi[삷̂
            //當`FbN
            if(isChecked == true && ("").equals(edtYear.getText().toString())){
                //ԃ_CAO\
                timePickerDialog = getTimeDialog(this);
                timePickerDialog.show();
                //t_CAO\
                datePickerDialog = getDateDialog(this);
                datePickerDialog.show();
            }else if(isChecked == true ){
            }else{
                //`FbNOꂽꍇ͉ʂ̓tƎ̍ڂ̒lɂ
                edtYear.setText("");
                edtMonth.setText("");
                edtDay.setText("");
                edtHour.setText("");
                edtMinuts.setText("");
            }
        }
    }
    /**
     * ݓ莞ԃ_CAO擾
     * @param act    ԃ_CAO\Acitivity
     * @return    ԕ\_CAO
     */
    private TimePickerDialog getTimeDialog(Activity act){
        //ݎ̃J_[擾
        final Calendar calendar = Calendar.getInstance();
        //J_[玞ƕ擾
        final int hour = calendar.get(Calendar.HOUR_OF_DAY);
        final int minute = calendar.get(Calendar.MINUTE);
        
        //ԃ_CAO쐬
        return new TimePickerDialog(
                act,
                new TimePickerDialog.OnTimeSetListener() {
                    /**
                     * ԃ_CAOŐݒ{^ꂽƂ̓ݒ
                     */
                    public void onTimeSet(TimePicker view, int hourOfDay, int minute) {
                        //ʂ̎ԂƕڂɁAԃ_CAOŐݒ肳ꂽlZbg
                        edtHour.setText(String.valueOf(hourOfDay));
                        edtMinuts.setText(String.valueOf(minute));
                    }
                },
                hour,
                minute,
                true);
    }
    /**
     * ݓt_CAO擾
     * @param act t_CAO\Acitivity
     * @return    t_CAO{bNX
     */
    private DatePickerDialog getDateDialog(Activity act){
        //ݎ̃J_[擾
        final Calendar calendar = Calendar.getInstance();
        //ݎNAA擾
        final int year = calendar.get(Calendar.YEAR);
        final int month = calendar.get(Calendar.MONTH);
        final int day = calendar.get(Calendar.DAY_OF_MONTH);
        
        //t_CAO擾
        return new DatePickerDialog(
                this,
                new DatePickerDialog.OnDateSetListener() {
                    /**
                     * t_CAOœtIAݒ{^̓
                     */
                    public void onDateSet(DatePicker view, int year,
                            int monthOfYear, int dayOfMonth) {
                        //ԃ_CAOŐݒ肳ꂽANAAʍڂɐݒ
                        edtYear.setText(String.valueOf(year));
                        edtMonth.setText(String.valueOf(monthOfYear+1));
                        edtDay.setText(String.valueOf(dayOfMonth));
                        
                    }
                },
                year,
                month,
                day);
    }

}
