package com.example.schedule.util;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.InputStream;
import java.io.OutputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Properties;
import java.util.Set;
import java.util.LinkedHashMap;

import com.example.schedule.info.ScheduleInfo;
import com.example.schedule.receiver.ScheduleAlarmReceiver;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;

public class ScheduleUtil {

    /**
     * t@C̏
     * @param context    ReLXg
     * @param str    t@Co͕
     * @param fileName    o̓t@C
     * @throws Exception
     */
    public static void writeFile(Context context,
        String str,String fileName) {
        writeBinaryFile(context,str.getBytes(),fileName);
    }
    /**
     * oCif[^t@Cւ̏
     * @param context    ReLXg
     * @param str    t@Co͕
     * @param fileName    o̓t@C
     * @throws Exception
     */
    public static void writeBinaryFile(Context context, byte[] data,String fileName) {
        OutputStream out=null;
        try {
        
            //t@Co̓Xg[Context擾
            out=context.openFileOutput(fileName,Context.MODE_PRIVATE);
            //t@Co̓Xg[Ƀf[^o
            out.write(data,0,data.length);
            //t@Co̓Xg[N[Y
            out.close();
        } catch (Exception e) {
            try {
                if (out!=null) out.close();
            } catch (Exception e2) {
            }
        }
    }
    /**
     * t@CXgOf[^̓ǂݍ
     * @param context    ReLXg
     * @param fileName    ǂݍ݃t@C
     * @return    ǂݍ݃t@C̕
     * @throws Exception
     */
    public static String readFile(Context context,
        String fileName) {
        //ǂݍ݃t@C̑݃`FbN
        if (!(new File(context.getFilesDir().getPath() + "/" + fileName)).exists()){
            return "";
        }
        //t@CoCgzœǂݍ
        byte[] w=readBinaryFile(context,fileName);
        return new String(w);
        
    }
    /**
     * oCit@C̓ǂݍ
     * @param context    ReLXg
     * @param fileName    ǂݍ݃t@C
     * @return    ǂݍ݃t@C̃oCgz
     * @throws Exception
     */
    public static byte[] readBinaryFile(Context context,
        String fileName) {
        int size;
        byte[] w=new byte[128]; 
        InputStream in=null;
        ByteArrayOutputStream out=null;
        try {
            //ContextCvbgXg[̎擾
            in=context.openFileInput(fileName);
            //oCgzOutputStream擾
            out=new ByteArrayOutputStream();
            //t@CǂݍByteArrayOutputStreamɒ߂
            while (true) {
                size=in.read(w);
                if (size<=0) break;
                out.write(w,0,size);
            }
            //ǂݍStreamƏoStream̃N[Y
            in.close();
            out.close();
            //ByteArrayStreamoCgz擾ԋp
            return out.toByteArray();
        } catch (Exception e) {
            try {
                if (in!=null) in.close();
                if (out!=null) out.close();
            } catch (Exception e2) {
            }
            return null;
        }
    }
    /**
     * vpeBt@C̓ǂݍ
     * @param context    ReLXg
     * @param fileName    ǂݍ݃t@C
     * @return    vpeB̒li[ꂽ}bvIuWFNg
     * @throws Exception 
     */
    public static HashMap<String, String> readProperties(Context context,String fileName) throws Exception{
        //t@C̑݃`FbN
        if (!(new File(context.getFilesDir().getPath() + "/" + fileName)).exists()){
            return null;
        }
        
        InputStream in=null;
        HashMap<String, String> ret = new LinkedHashMap<String, String>();
        Properties properties = new Properties();
        try {
            //t@CInputStream擾
            in=context.openFileInput(fileName);
            
            //vpeBt@C̃[h
            properties.load(in);
            
            //vpeB̃L[ƒlnbV}bvɊi[
            Set<Object> keys = properties.keySet();
            for (Iterator<Object> i = keys.iterator(); i.hasNext();) {
                String key = (String) i.next();
                String value = (String) properties.getProperty(key);
                ret.put(key, value); 
            }
            //InputStreamN[Y
            in.close();
            return ret;
        } catch (Exception e) {
            try {
                if (in!=null) in.close();
            } catch (Exception e2) {
            }
            return null;
        }
    }
    /**
     * }bvIuWFNg̃f[^vpeBt@Cɏo
     * @param context    ReLXg
     * @param map    vpeBt@Cɏo͂}bvIuWFNg
     * @param fileName    o̓t@C
     * @throws Exception
     */
    public static void writeProperties(Context context,HashMap<String, String> map ,String fileName) {
        OutputStream out=null;
        Properties properties = new Properties();

        try {
            //ReLXgOutputStream擾
            out=context.openFileOutput(fileName,
                    Context.MODE_PRIVATE);
            //}bvIuWFNgL[̒l擾
            Set<String> keys = map.keySet();    
            for (Iterator<String> i = keys.iterator(); i.hasNext();) {
                String key = (String) i.next();
                String value = (String) map.get(key);
                //vpeBɃL[ƒlݒ
                properties.setProperty(key, value); 
            }
            //vpeB̒lm肳
            properties.store(out, null);
            //OutputStreamN[Y
            out.close();
        } catch (Exception e) {
            try {
                if (out!=null) out.close();
            } catch (Exception e2) {
            }
            
        }
    }
    /**            
     * t̏`FbNp\bh            
     * @param date            
     * @return            
     */            
    public static boolean chkDate(String date){            
        boolean ret = false;        
        try {    
            SimpleDateFormat df = new SimpleDateFormat("yyyy/MM/dd hh:mm");        
            df.parse(date);
            ret = true;
        } catch (Exception e) {    
        }    
        return ret;    
    } 
    public static final String SCHEDULE_LIST_FILE = "schedule_list.txt";
    /**
     * XPW[XgeLXgɏ
     * @param sheduleList XPW[̃Xg
     */
    public static void writeScheduleList(Context ctx,ArrayList<ScheduleInfo> sheduleList){
        StringBuffer writStr = new StringBuffer();
        //XPW[Xg
        for(ScheduleInfo info : sheduleList){
            //ID,^CgAtAĂяotOs؂Œǉ
            writStr.append(info.getId()).append(",")
            .append(info.getTitle()).append(",")
            .append(info.getSchedule()).append("," )
            .append( info.isCallFlag() ) 
            .append(System.getProperty("line.separator"));
        }
        try {
            //쐬o
            writeFile(ctx,writStr.toString(),SCHEDULE_LIST_FILE);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    /**
     * XPW[Xg̎擾
     * @return    XPW[ꗗXg
     */
    public static ArrayList<ScheduleInfo> getScheduleList(Context ctx){
        ArrayList<ScheduleInfo> ret = new ArrayList<ScheduleInfo>();
        try {
            //schedule_list.txtf[^SĎ擾
            String fileStr = ScheduleUtil.readFile(ctx,SCHEDULE_LIST_FILE);
            //sR[hŕ
            String[] fileList =  fileStr.split(System.getProperty("line.separator"));
            //e[v
            for(int i = 0 ; i < fileList.length ; i++){
                //J}ŕ𕪊IDA^CgAtAĂяotOScheduleInfoɐݒ
                String[] wk = fileList[i].split(",");
                ScheduleInfo info = new ScheduleInfo();
                info.setId(Integer.parseInt(wk[0]));
                info.setTitle(wk[1]);
                info.setSchedule(wk[2]);
                info.setCallFlag(Boolean.parseBoolean(wk[3]));
                //쐬ScheduleInfoXgɒǉ
                ret.add(info);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        //XPW[ꗗXgԋp
        return ret;
    }
    /**
     * NXA[}l[W[ɓo^A1Ɏw肵NXs
     * @param ctx ReLXgw
     * 
     */
    public static void registAlarm(Context ctx){
        //ݓtԂ擾
        long nowTime = Calendar.getInstance().getTimeInMillis();
        //Intent쐬
        
        //uEUւ̕\T[rX̎s֕ύX
        //Uri uri = Uri.parse("http://google.com");
        //Intent intent = new Intent(Intent.ACTION_VIEW, uri);
        
        Intent intent = new Intent(ctx,ScheduleAlarmReceiver.class);

        //PendingIntent𐶐AIntentɎw肳ꂽNXA[}l[W[
        //IɎs
        //PendingIntentgetActivitygetBroadcast֕ύX
        //PendingIntent sender = PendingIntent.getActivity(ctx, 0, intent, Intent.FLAG_ACTIVITY_NEW_TASK);
        PendingIntent sender = PendingIntent.getBroadcast(ctx, 0, intent, Intent.FLAG_ACTIVITY_NEW_TASK);
        //A[}l[W[̎擾
        AlarmManager am = (AlarmManager)(ctx.getSystemService(Context.ALARM_SERVICE));
        
        //nowTime += 1 * 10 * 1000 ;
        //xs
        //am.set(AlarmManager.RTC_WAKEUP, nowTime, sender);
        
        //sԊu(b~b)
        long interval = 1 * 60 * 1000 ;
        //IɎs
        am.setRepeating(AlarmManager.RTC_WAKEUP,nowTime, interval, sender);
    }
}
