package com.example.rss.reader.activity;

import java.util.ArrayList;
import java.util.HashMap;

import com.example.rss.reader.R;
import com.example.rss.reader.provider.RssFeeds;
import com.example.rss.reader.service.RssReaderService;
import com.example.rss.reader.util.RssUtil;
import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.AdapterView.OnItemClickListener;
/**
 * Rss̈ꗗ\
 * o^ꂽRsstB[ḧꗗ\
 *
 */
public class RssListActivity extends Activity implements OnClickListener,OnItemClickListener{
    /**
     * RSStB[hListView
     */
    private ListView rssFeedList ;
    /**
     * RsstB[h̒ǉ{^
     */
    private Button addBtn;
    /**
     * Rss[_[̏I{^
     */
    private Button endBtn;
    /**
     * IvVj[@RSS̒ǉ
     */
    private static final int MENU_ID_ADD = (Menu.FIRST + 1);
    /**
     * IvVj[@RSS[_[̏I
     */
    private static final int MENU_ID_END = (Menu.FIRST + 2);

    /**
     * I𒆂̃XgID
     */
    private long selectListId;
    /**
     * XgIDƁARSSID̃}bsO
     */
    private HashMap<Long, String> idMap = new HashMap<Long, String>();
    /**
     * XgIDƁARssURL̃}bsO
     */
    private HashMap<Long, String> urlMap = new HashMap<Long, String>();
    /**
     * Rssꗗʂ̏\
     */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //ʊJnɃRecvoC_[擾ARssFeedsNXɐݒ
        RssFeeds.setContentResolver(getContentResolver());
        
        //Rss擾T[rX̋N
        Intent intent=new Intent(this,RssReaderService.class);
        startService(intent);

        //ʃCAEg
        LinearLayout linearLayout = new LinearLayout(this);
        linearLayout.setOrientation(LinearLayout.VERTICAL);
        setContentView(linearLayout);
        //{^CAEg
        LinearLayout btnLayout = new LinearLayout(this);
        btnLayout.setOrientation(LinearLayout.HORIZONTAL);
        
        //RssꗗXg
        rssFeedList  = new ListView(this);
        rssFeedList.setOnItemClickListener(this);
        getArrayAdapter();
        
        //Rssǉ{^
        addBtn = new Button(this);
        addBtn.setText("RsstB[h̒ǉ");
        addBtn.setOnClickListener(this);
        
        //Rss폜{^
        endBtn = new Button(this);
        endBtn.setText("Rss[_[̏I");
        endBtn.setOnClickListener(this);
        btnLayout.addView(addBtn,RssUtil.createParam(150, RssUtil.WC));
        btnLayout.addView(endBtn,RssUtil.createParam(150, RssUtil.WC));

        linearLayout.addView(btnLayout);
        linearLayout.addView(rssFeedList,RssUtil.createParam(RssUtil.FP, RssUtil.WC));
    }
    /**
     * ListView̕\ef[^x[X擾lōXV
     * @return ListAdapter
     */
    private void getArrayAdapter(){
        //RsstB[he[ulSăJ[\Ŏ擾
        Cursor mRSSCursor=RssFeeds.query(RssFeeds.RssFeedsColumns.CONTENT_URI,RssFeeds.RSSFEED_PROJECTION_MAP.keySet().toArray(new String[0]),null,null,null);
        ArrayList<String> rssList = new ArrayList<String>();
        int menuId = 0;
        //o^ĂRsstB[h[v
        while(mRSSCursor.moveToNext()){
            //e[ũJ擾Al擾
            //ID̃Jʒu擾l擾
            int rssIdCol     =mRSSCursor.getColumnIndex(RssFeeds.RssFeedsColumns._ID);
            String rssId = mRSSCursor.getString(rssIdCol);
            
            //L̃^Cg̃Jʒu擾l擾
            int rssChannelNameCol     =mRSSCursor.getColumnIndex(RssFeeds.RssFeedsColumns.CHANNEL_NAME);
            String channnelTitle = mRSSCursor.getString(rssChannelNameCol);
            
            //Lւ̃NiRss̔zMURLj̃Jʒu擾l擾
            int rssChannelLinkCol     =mRSSCursor.getColumnIndex(RssFeeds.RssFeedsColumns.CHANNEL_LINK);
            String channnelLink = mRSSCursor.getString(rssChannelLinkCol);
            
            //RsstB[hUrl̃Jʒu擾l擾
            int rssFeedUrlCol     =mRSSCursor.getColumnIndex(RssFeeds.RssFeedsColumns.CHANNEL_FEEDS_LINK);
            String feedUrl = mRSSCursor.getString(rssFeedUrlCol);
            
            //ListView̃XgIdrssid}bvIuWFNgɊi[
            idMap.put(new Long(menuId), rssId);
            //ListView̃XgIDRsstB[hUrl}bvIuWFNgɊi[
            urlMap.put(new Long(menuId), feedUrl);
            menuId++;
            
            //RsstB[hꗗɂ̓^CgRsstB[hURL\
            rssList.add(channnelTitle + System.getProperty("line.separator") + 
                    "\t" +    channnelLink);
        }
        String[] data = (String[]) rssList.toArray(new String[0]);
        //RsstB[hꗗʂf[^[x[XRsstB[h̒lōXV
        rssFeedList.setAdapter( new ArrayAdapter<String>(this, R.layout.rsslistlayout, data));
    }

    /**
     * ̉ʑJڂۂ̖߂莞Ɏs
     */
    @Override  
    protected void onActivityResult(int requestCode, int resultCode,Intent data){ 
        if (resultCode == RESULT_OK){  
            getArrayAdapter(); 
        }  
    }  
    /**
     * ʔjɌĂяo
     */
    @Override
    protected void onDestroy() {
        super.onDestroy();
    }
    /**
     * IvVj[̒ǉ
     */
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        menu.add(Menu.NONE, MENU_ID_ADD, Menu.NONE, "RsstB[h̒ǉ");
        menu.add(Menu.NONE, MENU_ID_END, Menu.NONE, "RsstB[h̍폜");
        return super.onCreateOptionsMenu(menu);
    }
    /**
     * j[{^̃CxgXi[
     */
    @Override
    public boolean onMenuItemSelected(int featureId, MenuItem item) {

        switch (item.getItemId()) {
        //RsstB[h̒ǉ
        case MENU_ID_ADD:
            startRegistRssActivity();
            break;
        //Rss[_[̏I
        case MENU_ID_END:
            finish();
            break;

        }

        return super.onMenuItemSelected(featureId, item);
    }
    /**
     * ListView̃XgĨCxgXi[
     */
    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position,long id) {
        if(parent == rssFeedList){
            selectListId=id;
            //IꂽRsstB[h̋Lꗗʂ֑J
            startReadRssActivity();
        }
    }
    /**
     * {^̃CxgXi[
     */
    @Override
    public void onClick(View view) {
        //RsstB[hǉ{^
        if(view == addBtn){
            //RsstB[hǉʂ֑J
            startRegistRssActivity();
        }else if(view == endBtn ){
            //AvP[VI
            finish();
        }
    }   
    /**
    * Rsso^ʂ֑J
    */
    private void startRegistRssActivity(){
        // Cegւ̃CX^X  
        Intent intent = new Intent(this,RegistRssFeedActivity.class);  
        String rssid = (String) idMap.get(new Long(selectListId)); 
        intent.putExtra("id", rssid);
        // Tu(Ceg)̋N  
        startActivityForResult(intent,0);
    }
    /**
    * Rss\ʂ֑J
    */
    private void startReadRssActivity(){

        // Cegւ̃CX^X  
        Intent intent = new Intent(this,RssArticleListActivity.class);  
        // RSS\ʂɃC UrlID𑗐M 
        String rssid = (String) idMap.get(new Long(selectListId)); 
        String url = (String) urlMap.get(new Long(selectListId)); 
        intent.putExtra("url", url);
        intent.putExtra("id", rssid);
        //RSS\ʂ̋N  
        startActivityForResult(intent,0); 
    }
}
