package com.example.rss.reader.parser;

import java.net.URL;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import com.example.rss.reader.provider.RssFeeds;
import android.content.ContentUris;
import android.content.ContentValues;
import android.net.Uri;
import android.util.Log;

/**
 * RsstB[hURL擾DOMIuWFNg͂
 * f[^x[Xփf[^ۑ
 */
public class RssParser {

    public static final String _TAG="RssParser";
    /**
     * UrlhLgIuWFNg擾
     * @param url RsstB[hURL
     * @return DocumentIuWFNg
     */
    public static Document fetch(String url){
        URL u=null;
        Document doc = null;
        try {
            //擾RsstB[hURLw
            u=new URL(url);
            //hLgr_[̐
            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            DocumentBuilder db = dbf.newDocumentBuilder();
            
            //URLhLgIuWFNg擾
            doc = db.parse(u.openStream());
            
        } catch (Exception e) {
            Log.e(_TAG,"ErrorF"+e.getMessage());
        }
        return doc;
    }

    /**
     * RsstB[h̒lRssFeedse[u֊i[iRsstB[ho^j
     * @param url RsstB[hURL
     * @param updHour XVԊu@Pʎ
     * @return f[^XVsR[hID
     */
    public static int parseRssFeed(String url,int updHour){
        //ID̏l
        int ret = -1;
        //RsstB[hURLhLgIuWFNg擾
        Document doc=fetch(url);
        
        //hLgIuWFNg擾łȂꍇ͏I
        if (doc==null){
            Log.w(_TAG,"hLg擾ł܂łB");
            return ret;
        }
        
        //hLg̒lf[^x[XɊi[邽߂ContentValuesIuWFNg̐
        ContentValues cv=new ContentValues();
        
        //RsstB[hUrli[
        cv.put(RssFeeds.RssFeedsColumns.CHANNEL_FEEDS_LINK, url);
        
        //XVԊu~bɕϊ@ԁ@~@@~@b@~@~bĊi[
        cv.put(RssFeeds.RssFeedsColumns.UPDATE_CYCLE, updHour * 60 * 60 * 1000);
        
        //hLgRSS2.0wb_[̃[gm[h擾
        NodeList nlHead=doc.getElementsByTagName("channel");
        
        //Rsswb_[channel^O̗vf[v
        for (int i=0;i<nlHead.getLength() ;i++ ){
            
            //m[h擾
            Node item=nlHead.item(i);
            //channelm[hqm[h擾
            NodeList childs=item.getChildNodes();
            //qm[h̗vf擾
            int childLen=childs.getLength();
            for (int childIndex=0;childIndex<childLen ;childIndex++ ){
                //m[h擾
                Node node=childs.item(childIndex);
                //m[h擾
                String nodeName=node.getNodeName();
                String nodeValue="";
                //m[h̒l擾
                Node el1=(Node)node.getFirstChild();
                if (el1!=null){
                    nodeValue=el1.getNodeValue();
                }else{
                    //Log.e(_TAG,"m[hF"+nodeName+"ɒl܂");
                }
                
                //m[ĥ̖^CgANAȀꍇ͒lContetValueɐݒ
                if(nodeName.equals("title")){
                    cv.put(RssFeeds.RssFeedsColumns.CHANNEL_NAME, nodeValue);
                }else if(nodeName.equals("link")){
                    cv.put(RssFeeds.RssFeedsColumns.CHANNEL_LINK, nodeValue);
                }else if(nodeName.equals("description")){
                    cv.put(RssFeeds.RssFeedsColumns.CHANNEL_DESC, nodeValue);
                }else if(nodeName.equals("language")){
                    cv.put(RssFeeds.RssFeedsColumns.CHANNEL_LANG ,nodeValue);
                }
            }
        }
        //ݎԂ擾i[
        long now=System.currentTimeMillis();
        cv.put(RssFeeds.RssFeedsColumns.LAST_UPDATE,now);
        
        //RssFeedsփf[^o^RsstB[hURLo^ĂȂ
        StringBuffer whereRessFeeds = new StringBuffer(RssFeeds.RssFeedsColumns.CHANNEL_FEEDS_LINK)
            .append(" like '%")
                .append(url)
                    .append("%'");
        
        //ContentValuesɐݒ肵lRssFeedse[u֑}Błɑ}Ăꍇ
        //RsstB[hIDԋp
        Uri rUri=RssFeeds.insertIfNotExists(RssFeeds.RssFeedsColumns.CONTENT_URI,
                whereRessFeeds.toString(),null,cv);
        
        //XVR[hID擾
        ret =  (int)ContentUris.parseId(rUri);
        
        
        return ret;
    }
    
    /**
     * RsstB[h̋L̓e擾Af[^x[Xɓo^
     * @param doc RsstB[h̃hLgIuWFNg
     * @param id DB֊i[ۂ̃R[hID
     */
    public static void parseRssContents(String url,String id){
        //RsstB[hURLhLgIuWFNg擾
        Document doc=fetch(url);
        if (doc==null){
            return;
        }
        //RsstB[h̋Lłitem^Õm[h擾
        NodeList nl=doc.getElementsByTagName("item");
        //item^O̗vf擾
        int nlen=nl.getLength();
        for (int i=0;i<nlen ;i++ ){
            Node item=nl.item(i);
            //item^O̎qm[h擾
            NodeList childs=item.getChildNodes();
            int childLen=childs.getLength();
            
            ContentValues cv=new ContentValues();
            //RssLf[^x[X֊i[ۂWhere쐬
            //channel_id=ID
            StringBuffer selection=new StringBuffer();
            selection.append(RssFeeds.RssFeedContentsColumns.CHANNEL_ID);
            selection.append("=");
            selection.append(id);

            cv.put(RssFeeds.RssFeedContentsColumns.CHANNEL_ID,id);
            //RssL[v
            for (int childIndex=0;childIndex<childLen ;childIndex++ ){
                Node node=childs.item(childIndex);
                //m[h擾
                String articleNodeName=node.getNodeName();
                
                //m[h̒l擾                
                String articleNodeValue="";                
                Node nodeValue=(Node)node.getFirstChild();
                if (nodeValue!=null){
                    articleNodeValue=nodeValue.getNodeValue();
                }else{
                    //Log.d(_TAG,"m[hF"+articleNodeName+"ɒl܂");
                }
                //NA^CgȀꍇ̒l擾
                if (articleNodeName.equalsIgnoreCase("link")){
                    cv.put(RssFeeds.RssFeedContentsColumns.ITEM_LINK,articleNodeValue);
                    //RssLXV邽߂Where쐬
                    //item_link=<rssLURL>
                    selection.append(" AND ")
                    .append(RssFeeds.RssFeedContentsColumns.ITEM_LINK)
                    .append("=")
                    .append("'")
                    .append(articleNodeValue)
                    .append("' ");
                }else if (articleNodeName.equalsIgnoreCase("title")){
                    cv.put(RssFeeds.RssFeedContentsColumns.ITEM_TITLE,articleNodeValue);
                }else if (articleNodeName.equalsIgnoreCase("description")){
                    cv.put(RssFeeds.RssFeedContentsColumns.ITEM_DESCRIPTION,articleNodeValue);
                }else if (articleNodeName.equalsIgnoreCase("pubDate")){
                    //Rss̋L̍XVԂ̏ꍇ
                    String pubDate = null;
                    try {
                        //XVԂ̃tH[}bgyyyy/MM/dd HH:mm:ssɕϊ
                        String pat = "EEE, dd MMM yyyy HH:mm:ss Z";
                        SimpleDateFormat sdf = new SimpleDateFormat(pat, Locale.US);
                        sdf.parse(articleNodeValue);
                        Date date = sdf.parse(articleNodeValue);
                        SimpleDateFormat format2 = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
                        pubDate = format2.format(date);
                        
                    } catch (ParseException e) {
                        e.printStackTrace();
                    }

                    cv.put(RssFeeds.RssFeedContentsColumns.PUB_DATE,pubDate);
                }
            }
            //RssFeedsContentse[uɃf[^}
            RssFeeds.insertIfNotExists(RssFeeds.RssFeedContentsColumns.CONTENT_URI,selection.toString(),null,cv);
        }
        //ݎԂ擾
        ContentValues cv=new ContentValues();
        long now=System.currentTimeMillis();
        cv.put(RssFeeds.RssFeedsColumns.LAST_UPDATE,now);
        
        //R[hIDXVRssFeedse[ũR[hUri擾
        Uri u=ContentUris.withAppendedId(RssFeeds.RssFeedsColumns.CONTENT_URI,Long.parseLong(id));
        //RssFeedse[uXV
        RssFeeds.update(u,cv,null,null);
    }
}
