package com.example.rss.reader.provider;

import android.content.ContentProvider;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.UriMatcher;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteQueryBuilder;
import android.net.Uri;
import android.text.TextUtils;
/**
 * 
 * ContentProviderp
 * }A폜AXVANG̔ss
 *
 */
public class RssProvider extends ContentProvider {
    
    private SQLiteDatabase mDB;    //DB̃IuWFNg
    
    // URL̃p[^
    // DBւ̃ANZX̍ۂURL擾ۂɁAΏۂ̃e[u𔻒f邽߂Ɏgp
    private static final int RSSFEEDS=1001;    //RssFeedse[uIDURȈꍇɕԋpl
    private static final int RSSFEED_ID=1002;    //RssFeedse[uIDLURȈꍇɕԋpl
    private static final int RSSFEED_CONTENTS=1003;    //RssFeedContentse[uIDURȈꍇɕԋpl
    private static final int RSSFEED_CONTENT_ID=1004;    //RssFeedContentse[uIDLURȈꍇɕԋpl
    
    /**
     * URL̃}b`Oϐ
     */
    private static final UriMatcher URL_MATCHER;

    static{
        //UrlMatcher̐
        URL_MATCHER=new UriMatcher(UriMatcher.NO_MATCH);
        //Urlucom.example.rss.reader/rssvłRSSFEEDSi=1001j̒lԋp
        URL_MATCHER.addURI("com.example.rss.reader","rss",RSSFEEDS);

        //Urlucom.example.rss.reader/rss/lvłRSSFEED_IDi=1002j̒lԋp
        URL_MATCHER.addURI("com.example.rss.reader","rss/#",RSSFEED_ID);
        //Urlucom.example.rss.reader/rsscontentsvłRSSFEED_CONTENTSi=1003j̒lԋp
        URL_MATCHER.addURI("com.example.rss.reader","rsscontents",RSSFEED_CONTENTS);
        
        //Urlucom.example.rss.reader/rsscontents/lvłRSSFEED_CONTENT_IDi=1004j̒lԋp
        URL_MATCHER.addURI("com.example.rss.reader","rsscontents/#",RSSFEED_CONTENT_ID);

    }
    /**
     * AvP[VNɌĂяo
     */
    @Override
    public boolean onCreate() {
        //f[^x[Xwp[̐
        RSSFeedDBHelper dbHelper=new RSSFeedDBHelper(getContext());
        
        //f[^x[Xwp[f[^x[XIuWFNg̎擾
        mDB=dbHelper.getWritableDatabase();
        
        return mDB!=null;
    }
    /**
     * 
     */
    @Override
    public String getType(Uri uri) {
        return null;
    }
    /**
     * f[^̑}
     * @param    uri    Insertse[uUri
     * @param    values    Insertsl
     * @return    Insertꂽf[^R[hUri
     */
    @Override
    public Uri insert(Uri uri, ContentValues values) {
        //Urivalue̊mF
        if (uri==null || values==null){
            throw new IllegalArgumentException("");
        }
        //UrlMatcherƁAnꂽUrlrAǂ̃e[uɃANZX悤ƂĂ邩
        int match=URL_MATCHER.match(uri);
        
        //InsertꂽR[hID
        long rowID=0;
        
        //UrlMatcherŔrꂽlŕ
        switch (match){
        case RSSFEEDS:    //Urihttp://com.example.rss.reader/rss̏ꍇ
            if (!values.containsKey(RssFeeds.RssFeedsColumns.CHANNEL_NAME)){
                throw new IllegalArgumentException("");
            }
            
            //RssFeedse[uContentValues̒lInsert
            rowID=mDB.insert("rssfeeds", "", values);
            
            if (rowID > 0) {
                //CT[gꂽUriIDt^ĕԋp
                Uri nUri = ContentUris.withAppendedId(RssFeeds.RssFeedsColumns.CONTENT_URI,rowID);
                getContext().getContentResolver().notifyChange(nUri, null);
                return nUri;
            }
            throw new SQLException(" " + uri);
        case RSSFEED_CONTENTS:    //Urihttp://com.example.rss.reader/rsscontents̏ꍇ
            //RssFeedContentse[uContentVlaues̒li[
            rowID=mDB.insert("rssfeedcontents", "", values);
            
            if (rowID > 0) {
                //CT[gꂽUriIDt^ĕԋp
                Uri nUri = ContentUris.withAppendedId(RssFeeds.RssFeedContentsColumns.CONTENT_URI,rowID);
                getContext().getContentResolver().notifyChange(nUri, null);
                return nUri;
            }
            throw new SQLException("" + uri);

        default:
            throw new IllegalArgumentException("" + uri);
        }
    }
    /**
     * f[^̍폜
     * @param    uri    Insertse[uUri
     * @param    selection    f[^폜ۂWhere
     * @param selectionArgs    selectionŁuHv𗘗pۂɒul
     * @return    폜
     */
    @Override
    public int delete(Uri uri, String selection, String[] selectionArgs) {
        int res=0;
        //Uri̊mF
        if (uri==null){
            throw new IllegalArgumentException("");
        }

        String feedID;
        int match=URL_MATCHER.match(uri);

        switch (match){

        case RSSFEED_ID:
            //WhereIDRssFeedse[ũf[^폜
            
            //UriID擾
            feedID=uri.getPathSegments().get(1);
            
            //IDɎw肳ꂽlRssFeedse[ũf[^폜
            res =  mDB.delete(
                "rssfeeds",
                //폜ΏۂIDw
                "_id=" + feedID
                //Where傪LꍇWhereǉ
                 + (!TextUtils.isEmpty(selection) ? " AND (" + selection
                 +  ')' : ""),
                selectionArgs);
            break;
            
        case RSSFEEDS:
            //WhereRssFeedse[ũf[^폜
            res =  mDB.delete(
                "rssfeeds",
                selection,
                selectionArgs
                );
            break;
            
        case RSSFEED_CONTENT_ID:
            //WhereIDRssFeedContentse[ũf[^폜
            //UriID擾
            feedID=uri.getPathSegments().get(1);
            
            //IDɎw肳ꂽlRssFeedContentse[ũf[^폜
            res =  mDB.delete(
                "rssfeedcontents",
                //폜ΏۂIDw
                "_id=" + feedID
                //Where傪LꍇWhereǉ
                 + (!TextUtils.isEmpty(selection) ? " AND (" + selection
                 +  ')' : ""),
                selectionArgs);

            break;
        case RSSFEED_CONTENTS:
            //WhereRssFeedContentse[ũf[^폜
            res =  mDB.delete(
                "rssfeedcontents",
                selection,
                selectionArgs
                );
            break;
        }

        getContext().getContentResolver().notifyChange(uri, null);
        return res;
    }
    /**
     * f[^̍XV
     * @param uri    f[^XV鏈se[uUri
     * @param    values    udpatesl
     * @param selection    f[^XVۂWhere
     * @param selectionArgs    selectionŁuHv𗘗pۂɒul
     * @return    XV
     */
    @Override
    public int update(Uri uri, ContentValues values, String selection, String[] selectionArgs) {
        int result=0;
        if (URL_MATCHER.match(uri)==RSSFEEDS){
            //RssFeedse[u̍XV
            
            //WhereRssFeedse[uXV
            result= mDB.update("rssfeeds", values, selection,selectionArgs);
            
            getContext().getContentResolver().notifyChange(uri, null);

        }else if (URL_MATCHER.match(uri)==RSSFEED_ID){
            //IDt^ꂽUriɂRssFeedse[u̍XV
            
            //UriID擾
            String feedID=uri.getPathSegments().get(1);
            
            //WhereRssFeedse[uXV
            result= mDB
                    .update("rssfeeds",
                        values,
                        //폜ΏۂIDw
                        "_id=" + feedID
                        //Where傪LꍇWhereǉ
                         + (!TextUtils.isEmpty(selection) ? " AND (" + selection
                         +  ')' : ""),
                        selectionArgs);

            getContext().getContentResolver().notifyChange(uri, null);

        }else{
            throw new IllegalArgumentException("Unsupported URL " + uri);
        }

        return result;
    }
    /**
     * NG[̔s
     * @param uri    f[^XV鏈se[uUri
     * @param projection    e[u̒lQƂ鍀ڂ̃Xg
     * @param selection    f[^擾ۂWhere
     * @param selectionArgs    selectionŁuHv𗘗pۂɒul
     * @param sortOrder    \[gږ
     * @return    f[^x[X擾J[\IuWFNg
     */
    @Override
    public Cursor query(Uri uri, String[] projection, String selection, String[] selectionArgs, String sortOrder) {
        //NGr_[̐
        SQLiteQueryBuilder qb = new SQLiteQueryBuilder();
        
        String orderBy=null;
        
        //UriUrlMatcherŔ肵
        switch (URL_MATCHER.match(uri)) {
        case RSSFEEDS:    //UriIDȂRssFeedse[uQ
            
            //e[uݒ
            qb.setTables("rssfeeds");
            //QƂ鍀ڂݒ
            qb.setProjectionMap(RssFeeds.RSSFEED_PROJECTION_MAP);
            
            //\[gږw肳ĂȂꍇ͏l̃\[g
            if (TextUtils.isEmpty(sortOrder)) {
                orderBy = RssFeeds.RssFeedsColumns.DEFAULT_SORT_ORDER;
            } else {
                orderBy = sortOrder;
            }
            break;
        case RSSFEED_ID:    //UriIDRssFeedse[uQ
            //e[uݒ
            qb.setTables("rssfeeds");
            
            //WhereUri擾IDw
            qb.appendWhere("_id=" + uri.getLastPathSegment());

            //\[gږw肳ĂȂꍇ͏l̃\[g
            if (TextUtils.isEmpty(sortOrder)) {
                orderBy = RssFeeds.RssFeedsColumns.DEFAULT_SORT_ORDER;
            } else {
                orderBy = sortOrder;
            }
            break;
        case RSSFEED_CONTENTS:    //UriIDȂRssFeedContentse[uQ
            //e[uݒ
            qb.setTables("rssfeedcontents");
            
            //QƂ鍀ڂݒ
            qb.setProjectionMap(RssFeeds.RSSCONTENT_PROJECTION_MAP);
            

            //\[gږw肳ĂȂꍇ͏l̃\[g
            if (TextUtils.isEmpty(sortOrder)) {
                orderBy = RssFeeds.RssFeedsColumns.DEFAULT_SORT_ORDER;
            } else {
                orderBy = sortOrder;
            }
            break;
        case RSSFEED_CONTENT_ID:    //UriIDRssFeedContentse[uQ
            //e[uݒ
            qb.setTables("rssfeedcontents");
            
            //WhereUri擾IDw
            qb.appendWhere("_id=" + uri.getLastPathSegment());

            //\[gږw肳ĂȂꍇ͏l̃\[g
            if (TextUtils.isEmpty(sortOrder)) {
                orderBy = RssFeeds.RssFeedsColumns.DEFAULT_SORT_ORDER;
            } else {
                orderBy = sortOrder;
            }
            break;
    
        default:
            throw new IllegalArgumentException("Unknown URL " + uri);
        }
        //NG𔭍săJ[\IuWFNg擾
        Cursor c = qb.query(mDB, projection, selection, selectionArgs, null,null, orderBy);
        
        c.setNotificationUri(getContext().getContentResolver(), uri);
        return c;
    }
}
