package com.example.rss.reader.service;


import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.os.IBinder;
import android.database.Cursor;
import android.util.Log;
import android.widget.Toast;
import android.content.Intent;

import com.example.rss.reader.R;
import com.example.rss.reader.activity.RssListActivity;
import com.example.rss.reader.parser.RssParser;
import com.example.rss.reader.provider.RssFeeds;



/**
 * Rssǂݍ݃T[rX
 * K̎ԂɂȂRss̓ǂݍ݂s
 * RunnableĂAXbhƂēƎRsstB[h擾Ă
 *
 */
public class RssReaderService extends Service implements Runnable{
    public static final String _TAG="RssReaderService";
    private boolean alive=false;    //Xbh̐
    
    private NotificationManager mNM;    //mbeBtBP[V}l[W

    private Thread t;    //Xbh

    private Cursor mRSSCursor;    //f[^x[X̃J[\


    /**
     * T[rX̐
     */
    @Override
    public void onCreate() {
        //mbeBtBP[V}l[W̎擾
        mNM = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
        showNotification(R.drawable.icon,
                "RSS[_[s܂",
                "RSS[_[T[rX",
                "RSS[_[T[rXJn܂");

        //g[Xg̕\
        Toast.makeText(this, "RssReaderServiceJn܂", Toast.LENGTH_SHORT).show();
        
        //T[rX̋NƓɃXbhs\Ԃɂ
        this.alive=true;
        
        //Xbh쐬
        t= new Thread(null, this, "RssReaderService");
        
        //Xbh̊Jn
        t.start();

    }

    /**
     * oCh̃Cxg
     * @param    i    IntentIuWFNg
     * @return    iBinder    IBinderIuWFNg
     */
    @Override
    public IBinder onBind(android.content.Intent i){
        return null;
    }
    /**
     * T[rXj
     */
    @Override
    public void onDestroy(){
        Toast.makeText(this, "RssReaderService~܂", Toast.LENGTH_SHORT).show();
        //Xbh̗LtOfalse
        this.alive=false;
        //Xbh̒~
        t.stop();
        //mbeBtBP[V}l[Wj
        mNM.cancel(0);
    }
    /**
     * RsstB[h̎擾
     */
    public void run() {
        //f[^[x[XRssFeeds̒l擾
        mRSSCursor=RssFeeds.query(RssFeeds.RssFeedsColumns.CONTENT_URI,RssFeeds.RSSFEED_PROJECTION_MAP.keySet().toArray(new String[0]),null,null,null);
        //ThreadtOL
        while (this.alive){
            try{
                //POԃXbhx~
                Thread.sleep(1 * 10 * 60 * 1000);
                
                //RssFeedse[u̒lĎ擾
                mRSSCursor.requery();
                
                //RssFeedse[ũ`ltB[hÑJʒu擾
                int rssCFeedLinkCol     =mRSSCursor.getColumnIndex(RssFeeds.RssFeedsColumns.CHANNEL_FEEDS_LINK);
                //RssFeedse[uID̃Jʒu擾
                int rssIDCol        =mRSSCursor.getColumnIndex(RssFeeds.RssFeedsColumns._ID);
                //RssFeedse[u̍XVԊũJʒu擾
                int rssUpdCyCol     =mRSSCursor.getColumnIndex(RssFeeds.RssFeedsColumns.UPDATE_CYCLE);
                //RssFeedse[u̍ŏIXṼJʒu擾
                int rssLastUpdCol       =mRSSCursor.getColumnIndex(RssFeeds.RssFeedsColumns.LAST_UPDATE);

                long now=System.currentTimeMillis();

                //RssFeeds̃R[h[v
                while (mRSSCursor.moveToNext()){
                    //f[^x[XŏIXVt擾
                    long lastUpdate=mRSSCursor.getLong(rssLastUpdCol);
                    //f[^x[XXVԊu擾
                    long updateCycle=mRSSCursor.getLong(rssUpdCyCol);
                    
                    //ŏIXVtƍXVԊu𑫂Č݂ÂȂRsstB[hURLl擾
                    if (lastUpdate+updateCycle < now){
                        //RssFeedse[uRsstB[hURL擾
                        String channel_feed_link = (String)mRSSCursor.getString(rssCFeedLinkCol);
                        //RssFeedse[uid擾
                        String id = (String)mRSSCursor.getString(rssIDCol);
                        //RsstB[hURLf[^擾f[^x[X֊i[
                        RssParser.parseRssContents(channel_feed_link,id);
                    }
                }
                //J[\񊈐
                mRSSCursor.deactivate();
            }catch(Exception e){
                Log.e(_TAG,"Error:"+e.getMessage());
                //e.printStackTrace();
            }
        }
        this.cleanup();
    }

    /**
     * XbhIɃJ[\N[Y
     */
    private void cleanup(){
        mRSSCursor.close();
    }
    /**
    /**
     * mbeBtBP[V̕\
     * @param context    ReLXg
     * @param iconID    ACRID
     * @param ticker    ÑbZ[W
     * @param title    mbeBtBP[Ṽ^Cg
     * @param message    mbeBtBP[Vɕ\郁bZ[W
     */
    private void showNotification(int iconID,String ticker,String title,String message) {
        
        //meBtBP[VIuWFNg̐
        Notification notification=new Notification(iconID,ticker,System.currentTimeMillis());
        
        //^XNo[ŃNbNꂽƂ̕\ANeBreBw
        Intent intent = new Intent(this,RssListActivity.class);
        
        //mbeBtBP[VꂽƂɎsPendingIntent̐
        PendingIntent pIntent=PendingIntent.getActivity(this,0,intent,Intent.FLAG_ACTIVITY_NEW_TASK);
        
        //mbeBtBP[VɃ^CgAbZ[WƁAsPendingIntent̐ݒ
        notification.setLatestEventInfo(this,title,message,pIntent);
        
        //meBtBP[V̕\
        mNM.notify(0,notification);
    }
}
