package com.example.camera.controll;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

import android.app.Activity;
import android.hardware.Camera;
import android.os.Bundle;
import android.os.Environment;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.Window;
import android.widget.Toast;

public class CameraActivity extends Activity implements SurfaceHolder.Callback,Camera.PictureCallback{
	private static  String SD_CARD_DIR = "";
	SurfaceView 			surfaceView ;	//T[tF[XView
	private SurfaceHolder	holder;			//z_[
	private Camera			camera;			//J
	/**
	 * 
	 */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //OXg[WfBNg̎擾
        File f =Environment.getExternalStorageDirectory();
        if(f != null && f.exists()){
        	//OXg[WfBNgݒ
            SD_CARD_DIR = f.getPath() + "/";
        }
        //AvP[V^Cg
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        
        //SurfaceView擾
        surfaceView = new SurfaceView(this);
        setContentView(surfaceView);
        
		//T[tFCXz_[̎擾
		holder=surfaceView.getHolder();
		
		//T[tFCXz_[ɃR[obN\bh̐ݒ
		holder.addCallback(this);
		
		//vbVobbt@̎w
		holder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
    }
    /**
     * T[tFCXT[tFCXz_[̐
     */
	@Override
	public void surfaceCreated(SurfaceHolder holder) {
		try{
			//JIuWFNg
			camera=Camera.open();
			camera.setPreviewDisplay(holder);
		}catch(IOException ioe){
			Toast.makeText(getBaseContext(), "J̋NɎs܂BAvP[VI܂B", Toast.LENGTH_LONG);
			finish();
		}
	}
	/**
	 * T[tFCXz_[ύX
	 */
	@Override
	public void surfaceChanged(SurfaceHolder holder,int format,int w,int h) {
		//Jvr[Jn
		Camera.Parameters parameters=camera.getParameters();
		parameters.setPreviewSize(w,h);
		camera.setParameters(parameters);
		camera.startPreview();
	}
	
	/**
	 * T[tFCXz_[j
	 */
	@Override
	public void surfaceDestroyed(SurfaceHolder holder) {
		//Jvr[~
		camera.stopPreview();
		camera.release();
	}
	
	/**
	 * ^b`CxgɃJŎBe
	 */
	@Override
	public boolean onTouchEvent(MotionEvent event) {
		if (event.getAction()==MotionEvent.ACTION_DOWN) {
			//JŎBe
			camera.takePicture(null,null,this); 
			camera.startPreview();
		}
		return true;
	}

	/**
	 * k摜p\̓삷
	 * 摜f[^SDJ[h֕ۑ
	 */
	@Override
	public void onPictureTaken(byte[] data,Camera camera) {
		//SDJ[hփoCgf[^̕ۑ
		FileOutputStream fos=null;
		try {
			fos=new FileOutputStream(SD_CARD_DIR+getDateTimeString()+".jpg");
			fos.write(data);
			fos.close();
			Toast.makeText(this, "SDJ[hɉ摜ۑ܂B", Toast.LENGTH_LONG).show();
		} catch (Exception e) {
			if (fos!=null){
				try {
					fos.close();
				} catch (IOException e1) {
				}
			}
			Toast.makeText(this, "摜t@C̕ۑɎs܂B"+e.getMessage(), Toast.LENGTH_LONG).show();
		}
	}
	/**
	 * VXet𕶎Ŏ擾
	 * 
	 * @param context
	 * @return tH[}bgς݂̓tƎ̕
	 */
	private static String getDateTimeString() {
		Date date = new Date(System.currentTimeMillis());
		SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd_HHmmss");
		return sdf.format(date);
	}

}