package com.example.backuprestore;
import android.app.Activity;
import android.app.backup.BackupManager;
import android.app.backup.RestoreObserver;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.RadioGroup;
import android.widget.Toast;

import java.io.File;
import java.io.IOException;
import java.io.RandomAccessFile;

/**
 * ʕ`您щʂɂē͂ꂽlAndroid̃t@Cɓo͂s
 * 
 *
 */
public class BackupRestoreActivity extends Activity {

	static final String TAG = "BackupRestoreActivity";
	
	private static final int RESTORE_SUCCESS = 0;

	/** t@Cɏ݂ۂ̓tO */
    static final Object[] sDataLock = new Object[0];

    /** f[^t@C */
    static final String DATA_FILE_NAME = "backup_data";

    /** ʂŗpUIIuWFNg */
    RadioGroup mSexGroup;
    
    CheckBox mAddHt03aCheckbox;
    CheckBox mAddXperiaCheckbox;
    CheckBox mAddIso3Checkbox;
    CheckBox mAddLynx3dCheckbox;
    CheckBox mAddGalaxy_sCheckbox;
    
    EditText mDescription;
    Button mBackup;
    Button mRestore;
    Button mSave;

    /** f[^t@C */
    File mLocalDataFile;

    /** obNAbv}l[WNX */
    BackupManager mBackupManager;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        /** obNAbvXgAʂUI`ݒ */
        setContentView(R.layout.main);

        /** UIIuWFNg̎擾 */
        mSexGroup = (RadioGroup) findViewById(R.id.sex_group);
        
        mAddHt03aCheckbox = (CheckBox) findViewById(R.id.ht03a);
        mAddXperiaCheckbox = (CheckBox) findViewById(R.id.xperia);
        mAddIso3Checkbox = (CheckBox) findViewById(R.id.iso3);
        mAddLynx3dCheckbox = (CheckBox) findViewById(R.id.lynx3d);
        mAddGalaxy_sCheckbox = (CheckBox) findViewById(R.id.galaxy_s);
        
        mDescription = (EditText) findViewById(R.id.description);
        mBackup = (Button) findViewById(R.id.backup);
        mRestore = (Button) findViewById(R.id.restore);
        mSave = (Button) findViewById(R.id.save);

        /** f[^t@C̎擾 */
        mLocalDataFile = new File(getFilesDir(), BackupRestoreActivity.DATA_FILE_NAME);

        /** obNAbv}l[W̎擾 */
        mBackupManager = new BackupManager(this);

        readFileToUI();
    }
    /**
     * 
     * f[^t@Clǂݍ݁Aʂ֐ݒ肷
     */
    private void readFileToUI() {
        RandomAccessFile file;
        
        // UIIuWFNg̏lݒ
        int sexFilling = R.id.male;
        boolean addHt03a = false;
        boolean addXperia = false;
        boolean addIso3 = false;
        boolean addLynx3d = false;
        boolean addGalaxy_s = false;
        String textvalue = "";
        
        /** f[^t@CɃANZX */
        synchronized (BackupRestoreActivity.sDataLock) {
            boolean exists = mLocalDataFile.exists();
            try {
                file = new RandomAccessFile(mLocalDataFile, "rw");
                if (exists) {
                    /** f[^t@C݂ꍇ͒l̓ǂݍ  */
                    Log.v(TAG, "datafile exists");
                    sexFilling = file.readInt();
                    addHt03a = file.readBoolean();
                    addXperia = file.readBoolean();
                    addIso3 = file.readBoolean();
                    addLynx3d = file.readBoolean();
                    addGalaxy_s = file.readBoolean();
                    textvalue = file.readUTF();
                } else {
                    /** f[^t@C݂Ȃꍇ͏lŃf[^t@C̍쐬 */
                    writeDataToFileLocked(file,
                            addHt03a, addXperia, addIso3, addLynx3d, addGalaxy_s,sexFilling,textvalue);
                    /** f[^t@C쐬ꂽƂobNAbv}l[Wɒʒm */
                    mBackupManager.dataChanged();
                }
            } catch (IOException ioe) {
                
            }
        }

        /** lUIIuWFNgɐݒ */
        mSexGroup.check(sexFilling);
        mAddHt03aCheckbox.setChecked(addHt03a);
        mAddXperiaCheckbox.setChecked(addXperia);
        mAddIso3Checkbox.setChecked(addIso3);
        mAddLynx3dCheckbox.setChecked(addLynx3d);
        mAddGalaxy_sCheckbox.setChecked(addGalaxy_s);
        
        mDescription.setText(textvalue);

    }
    /**
     * f[^t@Cւ̏݃\bh
     * @param file	t@CIuWFNg
     * @param addHt03a	ht03acheckboxIl
     * @param addXperia	xperiacheckboxIl
     * @param addIso3	iso3checkboxIl
     * @param addLynx3d	lynx3dcheckboxIl
     * @param addGalaxy_s	galaxy_scheckboxIl
     * @param sexFilling	ʂcheckboxIl
     * @param textValue	eLXgڂcheckboxIl
     * @throws IOException
     */
    void writeDataToFileLocked(RandomAccessFile file,
            boolean addHt03a, boolean addXperia,  boolean addIso3,  boolean addLynx3d,  boolean addGalaxy_s, 
            int sexFilling,String textValue)
        throws IOException {
            file.setLength(0L);
            file.writeInt(sexFilling);
            file.writeBoolean(addHt03a);
            file.writeBoolean(addXperia);
            file.writeBoolean(addIso3);
            file.writeBoolean(addLynx3d);
            file.writeBoolean(addGalaxy_s);
            file.writeUTF(textValue);
    }

    /**
     * ʂ̒lf[^t@Cɏ
     *
    */
    private void writeUItoFile() {
        boolean addHt03a = mAddHt03aCheckbox.isChecked();
        boolean addXperia = mAddXperiaCheckbox.isChecked();
        boolean addIso3 = mAddIso3Checkbox.isChecked();
        boolean addLynx3d = mAddLynx3dCheckbox.isChecked();
        boolean addGalaxy_s = mAddGalaxy_sCheckbox.isChecked();
        int sexFilling = mSexGroup.getCheckedRadioButtonId();
        String textValue = mDescription.getText().toString();
        try {
            synchronized (BackupRestoreActivity.sDataLock) {
                RandomAccessFile file = new RandomAccessFile(mLocalDataFile, "rw");
                writeDataToFileLocked(file, addHt03a, addXperia, addIso3, addLynx3d, addGalaxy_s, sexFilling,textValue);
            }
        } catch (IOException e) {
            Log.e(TAG, "UȈԂL^邱Ƃł܂B");
        }

    }
    
    /**
     * Save{^ɌĂяoBmain.xmlɂĐ錾B
     * @param v	Save{^
     */
    public void onSaveButtonClick(View v) {
		writeUItoFile();
        Toast.makeText(this, "[Jt@C㏑܂B", Toast.LENGTH_LONG).show();
    }
    
    /**
     * Backup{^ɌĂяoBmain.xmlɂĐ錾B
     * @param v	Backup{^
     */
    public void onBackupButtonClick(View v) {
		//dataChanged\bhŃobNAbv}l[Wɒʒm
        mBackupManager.dataChanged();
        Toast.makeText(this, "obNAbv̗\s܂B", Toast.LENGTH_LONG).show();
    }
    
    /**
     * Resore{^ɌĂяoBmain.xmlɂĐ錾B
     * @param v@Restore{^
     */
    public void onRestoreButtonClick(View v) {

        //t@Cǂݍ݂Ȃ
        int ret =mBackupManager.requestRestore(
                new RestoreObserver() {
                	public void restoreStarting(int numPackages){
                		Toast.makeText(BackupRestoreActivity.this, "f[^̃XgAJn܂B" , Toast.LENGTH_LONG).show();
                	}
                    public void restoreFinished(int error) {
                        readFileToUI();
            	        Toast.makeText(BackupRestoreActivity.this, "f[^̃XgAI܂B", Toast.LENGTH_LONG).show();
                    }
                }
        );
        if (ret != RESTORE_SUCCESS){
        	Toast.makeText(BackupRestoreActivity.this, "f[^XgAɃG[܂B", Toast.LENGTH_LONG).show();
        }
    }
}