package com.example.backuprestore;


import android.app.backup.BackupAgent;
import android.app.backup.BackupDataInput;
import android.app.backup.BackupDataOutput;
import android.os.ParcelFileDescriptor;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.RandomAccessFile;

public class MyBackupAgent extends BackupAgent {
    static final int AGENT_VERSION = 1;

    static final String APP_DATA_KEY = "backup_key";

    boolean mAddHt03a;
    boolean mAddXperia;
    boolean mAddIso3;
    boolean mAddLynx3d;
    boolean mAddGalaxy_s;
    int mSexFilling;
    String mText;
    File mDataFile;

    @Override
    public void onCreate() {
        mDataFile = new File(getFilesDir(), BackupRestoreActivity.DATA_FILE_NAME);
    }
    /**
     * obNAbvf[^ƃobNAbvf[^̍`FbN
     * @param oldState	obNAbvt@CfBXNv^
     * @param backupData	obNAbvf[^̏ݐ
     * @param newState	VKobNAbvt@CfBXNv^
     */
    @Override
    public void onBackup(ParcelFileDescriptor oldState, BackupDataOutput backupData,
            ParcelFileDescriptor newState) throws IOException {
    	
    	//Android[̃t@C̓ǂݍ
    	readLocalFile();

        boolean doBackup = (oldState == null);
        if (!doBackup) {
        	//obNAbvf[^̍`FbN
            doBackup = compareStateFile(oldState);
        }
        //OobNAbv̂ƍق΃obNAbvs
        if (doBackup) {
            ByteArrayOutputStream bufStream = new ByteArrayOutputStream();

            DataOutputStream outWriter = new DataOutputStream(bufStream);
            outWriter.writeInt(mSexFilling);
            outWriter.writeBoolean(mAddHt03a);
            outWriter.writeBoolean(mAddXperia);
            outWriter.writeBoolean(mAddIso3);
            outWriter.writeBoolean(mAddLynx3d);
            outWriter.writeBoolean(mAddGalaxy_s);
            outWriter.writeUTF(mText);

            byte[] buffer = bufStream.toByteArray();
            int len = buffer.length;
            
            //obNAbvf[^ɏ
            backupData.writeEntityHeader(APP_DATA_KEY, len);
            backupData.writeEntityData(buffer, len);
        }
        //Xe[^XXV
        writeStateFile(newState);
    }
    /**
     * ȑOobNAbvf[^ƍobNAbvsf[^̍`FbN
     * @param oldState	obNAbvt@CfBXNv^
     * @return	true:Afalse:Ȃ
     */
    private boolean compareStateFile(ParcelFileDescriptor oldState) {
        FileInputStream instream = new FileInputStream(oldState.getFileDescriptor());
        //obNAbvς݂̃t@C̃CvbgXg[擾
        DataInputStream oldInputStream = new DataInputStream(instream);

        try {
        	//obNAbvG[WFg̃o[WobNAbvς݂̃t@C̃o[W̏ꍇ̓obNAbv
            int stateVersion = oldInputStream.readInt();
            if (stateVersion > AGENT_VERSION) {
                return true;
            }
            //OobNAbveǂݍ
            int lastSexFilling = oldInputStream.readInt();
            boolean lastHt03a = oldInputStream.readBoolean();
            boolean lastXperia = oldInputStream.readBoolean();
            boolean lastIso3 = oldInputStream.readBoolean();
            boolean lastLynx3d = oldInputStream.readBoolean();
            boolean lastGalaxy_s = oldInputStream.readBoolean();
            String text = oldInputStream.readUTF();
            
            //ꂩ̍ڂOobNAbvlƈقȂĂ΃obNAbvs
            return (lastSexFilling != mSexFilling)
            		|| (lastHt03a != mAddHt03a)
		            || (lastXperia != mAddXperia)
                    || (lastIso3 != mAddIso3)
                    || (lastLynx3d != mAddLynx3d)
                    || (lastGalaxy_s != mAddGalaxy_s)
                    || (text != mText);
        } catch (IOException e) {
            return true;
        }
    }
    /**
     * Xe[^X̍XV
     * @param stateFile	XVt@CfBXNv^
     * @throws IOException
     */
    void writeStateFile(ParcelFileDescriptor stateFile) throws IOException {
        FileOutputStream outstream = new FileOutputStream(stateFile.getFileDescriptor());
        DataOutputStream out = new DataOutputStream(outstream);

        out.writeInt(AGENT_VERSION);
        out.writeInt(mSexFilling);
        out.writeBoolean(mAddHt03a);
        out.writeBoolean(mAddXperia);
        out.writeBoolean(mAddIso3);
        out.writeBoolean(mAddLynx3d);
        out.writeBoolean(mAddGalaxy_s);
        out.writeUTF(mText);
    }
    /**
     * XgA̎s
     * @param backupData	obNAbvf[^
     * @param appVersionCode	obNAbvAvP[Vo[W
     * @param newState	VɃobNAbvst@CfBXNv^
     * @throws IOException
     */
    @Override
    public void onRestore(BackupDataInput backupData, int appVersionCode,
            ParcelFileDescriptor newState) throws IOException {
        while (backupData.readNextHeader()) {
            String key = backupData.getKey();
            int dataSize = backupData.getDataSize();

            if (APP_DATA_KEY.equals(key)) {
                byte[] dataBuf = new byte[dataSize];
                //obNAbvf[^̒ldataBufɎ擾
                backupData.readEntityData(dataBuf, 0, dataSize);
                ByteArrayInputStream baStream = new ByteArrayInputStream(dataBuf);
                DataInputStream in = new DataInputStream(baStream);
                
                //obNAbvf[^̓ǂݍ
                mSexFilling = in.readInt();
                mAddHt03a = in.readBoolean();
                mAddXperia = in.readBoolean();
                mAddIso3 = in.readBoolean();
                mAddLynx3d = in.readBoolean();
                mAddGalaxy_s = in.readBoolean();
                mText = in.readUTF();
                
                //Android[̐ݒt@CɃobNAbvf[^̏
                writeLocalFile();
            } else {
            	//AvP[VL[vȂꍇ̓XLbv
                backupData.skipEntityData();
            }
        }
        //Xe[^XXV
        writeStateFile(newState);
    }
    /**
     * Android[̃t@Coϐ֓ǂݍ
     * @throws IOException
     */
    private void readLocalFile()throws IOException{

        synchronized (BackupRestoreActivity.sDataLock) {
            RandomAccessFile file = new RandomAccessFile(mDataFile, "r");
            mSexFilling = file.readInt();
            mAddHt03a = file.readBoolean();
            mAddXperia = file.readBoolean();
            mAddIso3 = file.readBoolean();
            mAddLynx3d = file.readBoolean();
            mAddGalaxy_s = file.readBoolean();
            mText = file.readUTF();
        }
    }
    /**
     * Android[̃t@Cփoϐ֏
     * @throws IOException
     */
    private void writeLocalFile() throws IOException{

        synchronized (BackupRestoreActivity.sDataLock) {
            RandomAccessFile file = new RandomAccessFile(mDataFile, "rw");
            file.setLength(0L);
            file.writeInt(mSexFilling);
            file.writeBoolean(mAddHt03a);
            file.writeBoolean(mAddXperia);
            file.writeBoolean(mAddIso3);
            file.writeBoolean(mAddLynx3d);
            file.writeBoolean(mAddGalaxy_s);
            file.writeUTF(mText);
        }
    }
}